<template>
  <div v-if="user" class="wallet-index-page">
    <template v-if="!isLogin && user.waves_address == ''">
      <div class="wallet-info">
        <div class="wallet-info__item">
          <div class="wallet-info__step">1</div>
          <div class="wallet-info__title">Create wallet</div>
          <div class="wallet-info__content">Yours. Secure. Profitable.</div>
          <div class="wallet-info__buttons">
            <div>
              <a
                href="https://play.google.com/store/apps/details?id=com.wavesplatform.wallet"
                target="_blank"
                v-wave
              >
                <span class="flex">
                  <span class="suffix"><svg-icon name="google-play" /></span>
                  <span class="value">Google Play</span>
                </span>
              </a>
            </div>
            <div>
              <a
                href="https://apps.apple.com/us/app/waves-wallet/id1233158971"
                target="_blank"
                v-wave
              >
                <span class="flex">
                  <span class="suffix"><svg-icon name="apple" /></span>
                  <span class="value">App Store</span>
                </span>
              </a>
            </div>
            <div>
              <a
                href="https://appgallery.huawei.com/#/app/C102860581"
                target="_blank"
                v-wave
              >
                <span class="flex">
                  <span class="suffix"><svg-icon name="huawei" /></span>
                  <span class="value">Huawei App Gallery</span>
                </span>
              </a>
            </div>
          </div>
        </div>
        <div class="wallet-info__item">
          <div class="wallet-info__step">2</div>
          <div class="wallet-info__title">Get balance</div>
          <div class="wallet-info__content">
            Top up your balance in USDN for amount you need, by any bank card.
          </div>
          <div class="wallet-info__video">
            <button v-wave>
              <span class="icon"><svg-icon name="play" /></span>
              <span class="title">Watch video</span>
            </button>
          </div>
        </div>
        <div class="wallet-info__item">
          <div class="wallet-info__step">3</div>
          <div class="wallet-info__title">Sign in</div>
          <div class="wallet-info__buttons">
            <div>
              <button @click="onAuthenticated()" v-wave>
                <span class="flex">
                  <span class="value">Waves.Exchange</span>
                  <span class="suffix"><svg-icon name="waves" /></span>
                </span>
              </button>
            </div>
            <div>
              <a
                href="https://waves.exchange/sign-up/software"
                target="_blank"
                class="primary"
                v-wave
              >
                <span class="flex">
                  <span class="value">Connect crypto wallet</span>
                </span>
              </a>
            </div>
          </div>
        </div>
      </div>
      <div class="wallet-questions">
        <div class="wallet-questions__h1">Questions</div>
        <Faq v-for="(item, index) in faq" :data="item" :key="index" />
      </div>
    </template>
    <template v-else-if="!isLogin && user.waves_address">
      <div class="waves-login">
        <div class="waves-login__top">
          <div class="waves-login__icon"><svg-icon name="waves" /></div>
          <div class="waves-login__title">Sign in to Wallet</div>
          <Button @click="onAuthenticated()" size="inline" v-wave
            >Waves.Exchange</Button
          >
        </div>
        <div class="waves-login__bottom">
          <div>Powered by WAVES Blockchain</div>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="wallet-account" v-if="user.waves_address">
        <div class="wallet-account__label">My address</div>
        <div class="wallet-account__token">{{ user.waves_address }}</div>
        <div class="wallet-account__nav">
          <el-tooltip
            slot="reference"
            effect="ulu"
            content="Share"
            placement="bottom"
          >
            <svg-icon name="share" />
          </el-tooltip>
          <el-tooltip effect="ulu" content="Copy" placement="bottom">
            <svg-icon name="copy" @click="onCopy(user.waves_address)" />
          </el-tooltip>
          <el-popover placement="bottom" trigger="click">
            <div style="padding: 10px; background: #252d45; font-size: 0">
              <VueQrcode :value="user.waves_address" :width="150" :margin="2" />
            </div>

            <el-tooltip
              slot="reference"
              effect="ulu"
              content="QR Code"
              placement="bottom"
            >
              <svg-icon name="qr" />
            </el-tooltip>
          </el-popover>
        </div>
      </div>
      <div class="wallet-navigation">
        <div @click="onBuy()"><Button>Buy</Button></div>
        <div><Button>Sell</Button></div>
      </div>

      <div class="wallet-balance">
        <div class="wallet-balance__row">
          <div
            v-for="(item, index) in userWallet.balance"
            :key="index"
            class="wallet-balance__item"
          >
            <div class="wallet-balance__title">{{ item.assetName }}</div>
            <div class="wallet-balance__tokens">
              {{ onCalc(item.amount, item.decimals) }}
            </div>
            <div class="wallet-balance__price">
              0$ <span class="status up">+0,00%</span>
            </div>
            <div class="wallet-balance__amount">0$</div>
          </div>
        </div>
        <div class="wallet-balance__more">
          <button v-wave>Hidden tokens <span>+</span></button>
        </div>
      </div>

      <div class="wallet-transactions__h1">Transactions</div>
      <div v-if="userWallet && userWallet.transactions">
        <Transaction
          v-for="(item, index) in userWallet.transactions[0]"
          :key="index"
          :data="item"
        />
      </div>
    </template>
  </div>
</template>

<script lang="ts">
import { defineComponent, computed, ref } from '@nuxtjs/composition-api'

import { useUpdateUserWavesTokenMutation } from '~/sdk/hooks'
import { CurrentUserFragment } from '@/sdk/types'

import elTooltip from '@/components/element/Tooltip.vue'

import Button from '@/components/ui/Button.vue'
import Faq from '@/components/profile/wallet/Faq.vue'
import Transaction from '@/components/profile/wallet/Transaction.vue'

import { Signer } from '@waves/signer'
import { ProviderCloud } from '@waves.exchange/provider-cloud'
//import { ProviderWeb } from '@waves.exchange/provider-web'
import VueQrcode from 'vue-qrcode'

const signer = new Signer(/*{
  // Укажите адрес ноды, подключенной к Testnet
  NODE_URL: 'https://nodes-testnet.wavesnodes.com'
}*/)
if (process.client) {
  signer.setProvider(new ProviderCloud())
}
export default defineComponent({
  name: 'WalletIndexPage',
  components: {
    elTooltip,
    Button,
    Faq,
    Transaction,
    VueQrcode
  },
  setup(_, { root }) {
    const user = computed(() => root.$accessor.auth.user)
    const isLogin = ref(false)
    const userWallet = ref({
      address: '',
      balance: {},
      transactions: []
    })

    const { mutate, loading, onDone } = useUpdateUserWavesTokenMutation({})
    const userId = user.value?.id as string

    const onAuthenticated = async () => {
      if (!isLogin.value) {
        try {
          const connect = await signer.login()
          const balances = await signer.getBalance()
          const transactions = await root.$axios.$get<any>(
            'https://nodes.wavesnodes.com/transactions/address/' +
              connect.address +
              '/limit/1000'
          )
          userWallet.value.address = connect.address
          userWallet.value.balance = balances
          userWallet.value.transactions = transactions

          await mutate({
            userId: userId,
            waves_address: connect.address
          })

          isLogin.value = true
        } catch (error) {
          console.log(error.message)
        }
      } else {
        console.log('Выход')
      }
    }

    const onBuy = async () => {
      try {
        const data = {
          dApp: '3P3tqaeh4YQLUPg4HcbPntE7FUzzSFdftCg', //ULU
          call: {
            function: 'makePayment',
            args: [
              {
                type: 'string',
                value: '3PNWtZmDfTqfTTgVf3NDcqe94q2XJGLtJrF' //recipient  alex
              }
            ]
          },
          payment: [
            {
              assetId: 'DG2xFkPdDwKUoBkzGAhQtLpSGzfXLiCYPEzeKH2Ad24p', //USDN
              //            assetId: null, //WAVES
              amount: 1000
            }
          ],
          //          fee: LONG,
          feeAssetId: 'DG2xFkPdDwKUoBkzGAhQtLpSGzfXLiCYPEzeKH2Ad24p' //USDN
        }

        await signer
          .invoke(data as any)
          .broadcast()
          .then(
            response => {
              console.log(response)
            },
            error => {
              console.error(error)
            }
          )
      } catch (error) {
        console.log(error.message)
      }
    }

    const onCopy = (data: string) => {
      navigator.clipboard.writeText(data)
      root.$message.success('Данные скопированы')
    }

    const faq = [
      {
        title: 'Why do I need wallet?',
        content:
          'First of all for purchasing services that our makers do, for keeping service secure, because wallet is owned by you.'
      },
      {
        title: 'Created, what’s next?',
        content:
          'Top up your balance in USDN for amount you need, then press Sign in button, you will see your active balances, now you can pay!'
      },
      {
        title: 'App comission',
        content:
          'We charge 0.3% per transaction, and 3% from makers goods and services, commission goes for developing our platform.'
      },
      {
        title: 'Security information',
        content:
          'Waves.Exchange wallet is most secure wallet, secured by your seed phrase, nobody has access to it, our app is using only sign methods, that’s mean you approve every transaction by yourself, we don’t store your password or seed phrase.'
      },
      {
        title: 'Have a question?',
        content:
          'Just mail us <a href="mailto:support@ulu.world">support@ulu.world</a>'
      }
    ]

    const onCalc = (amount: any, decimals: any) => {
      return amount / Math.pow(10, decimals)
    }

    return {
      user,

      onCopy,
      onCalc,
      onAuthenticated,
      isLogin,
      userWallet,
      faq,
      onBuy
    }
  }
})
</script>

<style lang="scss" scoped>
.waves-login {
  background: #292e3c;
  border-radius: 10px;
  display: flex;
  flex-direction: column;
  padding: 40px 20px;
  min-height: 80vh;
  text-align: center;
  &__top {
    flex: 1;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
  }
  &__bottom {
    padding-top: 40px;
    letter-spacing: 0px;
    color: #8591ad;
    font-size: 16px;
    line-height: 20px;
    text-align: center;
  }
  &__icon {
    font-size: 0px;
    margin-bottom: 35px;
    padding: 20px;
    background: #fff;
    border-radius: 10px;
    svg {
      width: 32px;
      height: 32px;
    }
  }
  &__title {
    letter-spacing: -0.75px;
    color: #ffffff;
    font-weight: bold;
    font-size: 30px;
    line-height: 38px;
    margin-bottom: 30px;
  }
}
.wallet {
  &-info {
    margin-bottom: 40px;
    @media (min-width: 991.98px) {
      margin-bottom: 60px;
    }
    &:first-child {
      margin-top: 35px;
      @media (min-width: 991.98px) {
        margin-top: 30px;
      }
    }
    &:last-child {
      margin-bottom: 0px;
    }
    &__item {
      background: #292e3c;
      border-radius: 10px;
      padding: 45px 25px 55px 25px;
      margin-bottom: 10px;
      text-align: center;
      @media (min-width: 991.98px) {
        margin-bottom: 13px;
        padding: 50px 25px 60px 25px;
      }
      &:last-child {
        margin-bottom: 0px;
        padding-bottom: 25px;
        @media (min-width: 991.98px) {
          padding-bottom: 60px;
        }
      }
    }
    &__step {
      background: #0065ff;
      box-shadow: 0 0 0 10px #1f232f;
      border-radius: 50%;
      width: 45px;
      height: 45px;
      display: flex;
      align-items: center;
      justify-content: center;
      letter-spacing: 0px;
      color: #ffffff;
      font-size: 24px;
      line-height: 24px;
      font-weight: bold;
      margin: -72px auto 30px auto;
      padding-bottom: 1px;
      padding-left: 1px;
      @media (min-width: 991.98px) {
        margin: -80px auto 40px auto;
        width: 50px;
        height: 50px;
        box-shadow: 0 0 0 12px #1f232f;
      }
    }
    &__title {
      letter-spacing: -0.75px;
      color: #ffffff;
      font-size: 30px;
      line-height: 38px;
      font-weight: bold;
      margin-bottom: 5px;
    }
    &__content {
      letter-spacing: 0px;
      letter-spacing: 0px;
      color: #9badd6;
      font-size: 18px;
      line-height: 22px;
      @media (min-width: 991.98px) {
        font-size: 22px;
        line-height: 27px;
      }
    }
    &__buttons {
      margin: 25px auto 0 auto;
      @media (min-width: 991.98px) {
        max-width: 300px;
      }
      > * {
        margin-bottom: 15px;
        @media (min-width: 991.98px) {
          margin-bottom: 10px;
        }
        &:last-child {
          margin-bottom: 0px;
        }
      }
      a,
      button {
        border: 0;
        outline: none;
        background: #363b4d;
        border-radius: 10px;
        width: 100%;
        display: block;
        .flex {
          display: flex;
          align-items: center;
          justify-content: center;
          padding: 10px;
          height: 60px;
        }
        .value {
          letter-spacing: 0px;
          color: #ffffff;
          font-weight: 500;
          font-size: 18px;
          line-height: 18px;
        }
        .suffix {
          flex: none;
          margin-right: 13px;
          font-size: 0px;
          &:last-child {
            margin-right: 0px;
            margin-left: 13px;
          }
          img,
          svg {
            width: 20px;
            height: 20px;
          }
        }
        &.primary {
          background: rgba(#0065ff, 0.2);
          .value {
            color: #5c98f4;
          }
        }
      }
    }
    &__video {
      margin-top: 20px;
      text-align: center;
      button {
        background: #363b4d 0% 0%;
        border-radius: 20px;
        border: 0;
        outline: none;
        padding: 10px 15px 10px 10px;
        display: inline-flex;
        align-items: center;
        .icon {
          background: #c94344;
          border-radius: 50%;
          width: 22px;
          height: 22px;
          display: flex;
          align-items: center;
          justify-content: center;
          svg {
            fill: #fff;
            width: 8px;
            height: 8px;
          }
        }
        .title {
          letter-spacing: 0px;
          color: #ffffff;
          font-size: 18px;
          line-height: 18px;
          font-weight: 500;
          margin-left: 10px;
        }
      }
    }
  }
  &-questions {
    &__h1 {
      letter-spacing: 0px;
      color: #ffffff;
      letter-spacing: -0.75px;
      color: #ffffff;
      font-size: 30px;
      line-height: 38px;
      font-weight: bold;
      text-align: center;
      margin-bottom: 20px;
      @media (min-width: 991.98px) {
        text-align: left;
        margin-bottom: 30px;
      }
    }
  }
  &-account {
    box-shadow: 0px 3px 6px #00000029;
    border: 2px solid #373e57;
    border-radius: 10px;
    padding: 15px 35px 15px 25px;
    margin-bottom: 20px;
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    grid-template-rows: repeat(2, 1fr);
    align-items: center;
    &__label {
      grid-area: 1 / 1 / 2 / 2;
      letter-spacing: 0px;
      color: #ffffff;
      font-size: 18px;
      line-height: 18px;
      font-weight: 500;
    }
    &__token {
      grid-area: 2 / 1 / 3 / 2;
      letter-spacing: 0px;
      color: #8591ad;
      font-size: 18px;
      line-height: 24px;
      font-weight: 500;
    }
    &__nav {
      grid-area: 1 / 2 / 3 / 3;
      display: flex;
      justify-content: flex-end;
      font-size: 0px;
      svg {
        width: 20px;
        height: 20px;
        fill: #8591ad;
      }
      > * {
        margin-left: 30px;
        &:first-child {
          margin-left: 0px;
        }
      }
    }
  }
  &-navigation {
    display: grid;
    grid-template-columns: 1fr 1fr;
    grid-gap: 20px;
    margin-bottom: 20px;
  }
  &-balance {
    margin-bottom: 55px;
    &:last-child {
      margin-bottom: 0px;
    }
    &__item {
      background: #292e3c;
      border-radius: 10px;
      padding: 28px 30px;
      margin-bottom: 20px;
      display: grid;
      grid-template-columns: 1fr 1fr;
      grid-row-gap: 15px;
      align-items: flex-end;
    }
    &__title {
      letter-spacing: 0px;
      color: #ffffff;
      font-size: 30px;
      line-height: 38px;
      font-weight: bold;
    }
    &__tokens {
      letter-spacing: -1.13px;
      color: #ffffff;
      font-size: 45px;
      line-height: 36px;
      font-weight: bold;
      text-align: right;
    }
    &__amount {
      letter-spacing: 0px;
      color: #9badd6;
      font-size: 20px;
      line-height: 25px;
      text-align: right;
    }
    &__price {
      letter-spacing: 0px;
      color: #8591ad;
      font-size: 20px;
      line-height: 25px;
      span {
        margin-left: 10px;
        &.up {
          color: #2ab580;
        }
        &.down {
          color: #dd5b5b;
        }
      }
    }
    &__more {
      margin-top: 25px;
      button {
        background: #292e3c;
        border: 0;
        outline: none;
        border-radius: 25px;
        padding: 10px 20px;
        letter-spacing: 0px;
        color: #ffffff;
        font-weight: 500;
        font-size: 18px;
        line-height: 23px;
        cursor: pointer;
        span {
          margin-left: 6px;
          color: #00ffb3;
          font-size: 20px;
          line-height: 20%;
          font-weight: bold;
        }
      }
    }
  }
  &-transactions {
    margin-bottom: 20px;
    background: #292e3c;
    border-radius: 10px;
    &__h1 {
      letter-spacing: 0px;
      color: #ffffff;
      font-size: 24px;
      line-height: 33px;
      font-weight: 500;
      margin-bottom: 25px;
    }
  }
}
</style>
